<template>
    <Page actionBarHidden="true">
        <FlexboxLayout
            flexDirection="column"
            justifyContent="center"
            class="full-height"
        >
            <StackLayout class="logo-container">
                <Image
                    src="~/assets/images/logo.png"
                    class="logo"
                    stretch="fill"
                ></Image>
            </StackLayout>

            <StackLayout class="container">
                <Label class="title">Connexion</Label>
                <Label class="error" v-if="this.error !== ''" :text="this.error"/>
                <FlexboxLayout alignItems="center" class="border-bottom">
                    <Image
                        src="~/assets/images/mail.png"
                        class="icon-margin"
                        stretch="fill"
                    ></Image>
                    <TextField
                        v-model="loginForm.emailInput"
                        hint="Adresse mail"
                        keyboardType="email"
                        class="form-input"
                    />
                </FlexboxLayout>
                <FlexboxLayout alignItems="center" class="border-bottom">
                    <Image
                        src="~/assets/images/password.png"
                        class="icon-margin"
                        stretch="fill"
                    ></Image>
                    <TextField
                        v-model="loginForm.passwordInput"
                        hint="Mot de passe"
                        secure="true"
                        class="form-input"
                    />
                </FlexboxLayout>

                <Button text="Me connecter" @tap="signUp()" class="my-button"/>

            </StackLayout>
        </FlexboxLayout>
    </Page>
</template>

<script>
import {Couchbase} from 'nativescript-couchbase-plugin';

const database = new Couchbase('atp_base');

export default {
    data() {
        return {
            loginForm: {
                emailInput: "",
                passwordInput: "",
            },
            error: "",
        };
    },
    mounted() {
        let db = database.query({select: []})
        if (db.length === 1) {
            let token = db[0].userStore.refresh_token
            if (token) {
                this.$store.dispatch("refresh", token).then((response) => {
                    if (response.statusCode === 201) {
                        const userStore = this.$store.getters["user"];
                        database.updateDocument(db[0].id, {userStore});
                        this.$navigateTo(this.$routes.Home);
                    } else {
                        this.error = "Veuillez vous reconnecter !";
                        database.deleteDocument(db[0].id)
                    }
                });
            }
        }
    },
    methods: {
        signUp() {
            this.$store.dispatch("trySignin", this.loginForm).then((response) => {
                if (response.statusCode === 200) {
                    const userStore = this.$store.getters["user"];
                    const documentId = database.createDocument({userStore});
                    this.$navigateTo(this.$routes.Home);
                } else {
                    var errorLog = response.content.toJSON();
                    this.error = errorLog.error;
                }
            });
        },
    },
};
</script>

<style scoped>
.title {
    text-align: center;
    font-size: 25px;
    color: #2d2d2d;
    margin-bottom: 50;
    margin-top: 10;
}

.error {
    text-align: center;
    color: red;
}

.border-bottom {
    border-bottom-width: 1;
    border-bottom-color: #2d2d2d;
    margin-bottom: 20;
    margin-left: 15;
    margin-right: 15;
}

.form-input {
    color: #2d2d2d;
    placeholder-color: #2d2d2d;
    border-bottom-width: 1;
    border-color: white;
}

.icon-margin {
    margin-right: 10;
    width: 16;
    height: 16;
}

.my-button {
    background-color: #339e33;
    color: white;
    border-radius: 10;
    padding: 5 15;
    text-transform: uppercase;
    letter-spacing: 0.1;
    margin: 50px 70px 20;
    font-size: 10;
}

.full-height {
    background-image: url("~/assets/images/background.png");
    background-size: cover;
    background-repeat: no-repeat;
}

.logo-container {
    margin-left: 100;
    margin-right: 100;
    margin-bottom: 58;
}

.logo {
    width: 150vw;
    height: 150vh;
}

.container {
    background-color: white;
    border-radius: 15;
    margin-left: 48;
    margin-right: 48;
    padding: 15px;
}
</style>
